/*
 * WSO2 API Manager - Publisher API
 * This specifies a **RESTful API** for WSO2 **API Manager** - Publisher.  Please see [full swagger definition](https://raw.githubusercontent.com/wso2/carbon-apimgt/v6.0.4/components/apimgt/org.wso2.carbon.apimgt.rest.api.publisher/src/main/resources/publisher-api.yaml) of the API which is written using [swagger 2.0](http://swagger.io/) specification. 
 *
 * OpenAPI spec version: v1.1
 * Contact: architecture@wso2.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package org.wso2.am.integration.clients.publisher.api.v1.dto;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ScopeDTO
 */

public class ScopeDTO {
  @SerializedName("id")
  private String id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("displayName")
  private String displayName = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("bindings")
  private List<String> bindings = null;

  @SerializedName("usageCount")
  private Integer usageCount = null;

  public ScopeDTO id(String id) {
    this.id = id;
    return this;
  }

   /**
   * UUID of the Scope. Valid only for shared scopes. 
   * @return id
  **/
  @ApiModelProperty(example = "01234567-0123-0123-0123-012345678901", value = "UUID of the Scope. Valid only for shared scopes. ")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public ScopeDTO name(String name) {
    this.name = name;
    return this;
  }

   /**
   * name of Scope 
   * @return name
  **/
  @ApiModelProperty(example = "apim:api_view", required = true, value = "name of Scope ")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ScopeDTO displayName(String displayName) {
    this.displayName = displayName;
    return this;
  }

   /**
   * display name of Scope 
   * @return displayName
  **/
  @ApiModelProperty(example = "api_view", value = "display name of Scope ")
  public String getDisplayName() {
    return displayName;
  }

  public void setDisplayName(String displayName) {
    this.displayName = displayName;
  }

  public ScopeDTO description(String description) {
    this.description = description;
    return this;
  }

   /**
   * description of Scope 
   * @return description
  **/
  @ApiModelProperty(example = "This Scope can used to view Apis", value = "description of Scope ")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ScopeDTO bindings(List<String> bindings) {
    this.bindings = bindings;
    return this;
  }

  public ScopeDTO addBindingsItem(String bindingsItem) {
    if (this.bindings == null) {
      this.bindings = new ArrayList<>();
    }
    this.bindings.add(bindingsItem);
    return this;
  }

   /**
   * role bindings list of the Scope 
   * @return bindings
  **/
  @ApiModelProperty(example = "[\"admin\",\"Internal/creator\",\"Internal/publisher\"]", value = "role bindings list of the Scope ")
  public List<String> getBindings() {
    return bindings;
  }

  public void setBindings(List<String> bindings) {
    this.bindings = bindings;
  }

  public ScopeDTO usageCount(Integer usageCount) {
    this.usageCount = usageCount;
    return this;
  }

   /**
   * usage count of Scope 
   * @return usageCount
  **/
  @ApiModelProperty(example = "3", value = "usage count of Scope ")
  public Integer getUsageCount() {
    return usageCount;
  }

  public void setUsageCount(Integer usageCount) {
    this.usageCount = usageCount;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ScopeDTO scope = (ScopeDTO) o;
    return Objects.equals(this.id, scope.id) &&
        Objects.equals(this.name, scope.name) &&
        Objects.equals(this.displayName, scope.displayName) &&
        Objects.equals(this.description, scope.description) &&
        Objects.equals(this.bindings, scope.bindings) &&
        Objects.equals(this.usageCount, scope.usageCount);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, displayName, description, bindings, usageCount);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ScopeDTO {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    displayName: ").append(toIndentedString(displayName)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    bindings: ").append(toIndentedString(bindings)).append("\n");
    sb.append("    usageCount: ").append(toIndentedString(usageCount)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

